package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HREmpState;
import cn.ibizlab.humanresource.core.humanresource.filter.HREmpStateSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HREmpState] 服务对象接口
 */
public interface IHREmpStateService extends IService<HREmpState>{

    boolean create(HREmpState et) ;
    void createBatch(List<HREmpState> list) ;
    boolean update(HREmpState et) ;
    void updateBatch(List<HREmpState> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HREmpState get(String key) ;
    HREmpState getDraft(HREmpState et) ;
    boolean checkKey(HREmpState et) ;
    boolean save(HREmpState et) ;
    void saveBatch(List<HREmpState> list) ;
    Page<HREmpState> searchDefault(HREmpStateSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HREmpState> getHrempstateByIds(List<String> ids) ;
    List<HREmpState> getHrempstateByEntities(List<HREmpState> entities) ;
}


